package com.github.huangp.learning.ga.travellingsalemanproblem;

import java.util.List;
import java.util.Set;

import com.google.common.collect.ImmutableSet;
import com.google.common.collect.Lists;

/**
 * @author Patrick Huang
 *         <a href="mailto:pahuang@redhat.com">pahuang@redhat.com</a>
 */
public class DestinationCities {
    private static final DestinationCities CITIES = new DestinationCities();
    private List<City> cities = Lists.newArrayList();

    private DestinationCities() {
    }

    public static DestinationCities manager() {
        return CITIES;
    }

    public boolean addCity(City city) {
        if (cities.contains(city)) {
            return false;
        }
        cities.add(city);
        return true;
    }

    public City getCity(int index) {
        return cities.get(index);
    }
    public int numOfCities() {
        return cities.size();
    }

    public Set<City> getCities() {
        return ImmutableSet.<City>builder().addAll(cities).build();
    }
}
