package com.github.huangp.learning.sorting;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.Test;
import com.github.huangp.learning.sorting.MergeSort;

/**
 * @author Patrick Huang <a
 *         href="mailto:pahuang@redhat.com">pahuang@redhat.com</a>
 */
public class MergeSortTest {
    private MergeSort sort = new MergeSort();

    @Test
    public void canSort() {
        int[] result = { 2, 3, 4, 1, 7, 9, 5 };
        sort.sort(result);
        assertThat(result).containsExactly(1, 2, 3, 4, 5, 7, 9);
    }

    @Test
    public void canSortSingle() {
        int[] result = { 1 };
        sort.sort(result);
        assertThat(result).containsExactly(1);
    }

    @Test
    public void canHandleDuplicateValues() {
        int[] result = { 3, 2, 2, 1 };
        sort.sort(result);
        assertThat(result).containsExactly(1, 2, 2, 3);
    }
}
